﻿using System;
using System.Diagnostics;
using System.Threading.Tasks;
using Plugin.Geolocator;
using Plugin.Geolocator.Abstractions;

namespace AgClockingClockout.iOS.Helpers
{
    public class GpsHelper
    {
        public static async Task<Position> GetCurrentPosition()
        {
            Position position = null;
            try
            {
                var locator = CrossGeolocator.Current;
                locator.DesiredAccuracy = 300;

                position = await locator.GetLastKnownLocationAsync();

                if (position != null)
                {
return position;
                }

                if (!locator.IsGeolocationAvailable || !locator.IsGeolocationEnabled)
                {
                    //not available or enabled
                    return null;
                }

                position = await locator.GetPositionAsync(TimeSpan.FromSeconds(15), null, true);

            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex);
            }

            if (position == null)
                return null;
                
                return position;
        }

    }
}
