using Acr.UserDialogs;
using AgClockingClockout.iOS.Helpers;
using Foundation;
using Newtonsoft.Json;
using RestSharp;
using System;
using System.Collections.Generic;
using UIKit;
using static AgClockingClockout.iOS.Helpers.Models;

namespace AgClockingClockout.iOS
{
    public partial class SummaryOutController : UIViewController
    {
        public string DataHelper { get; set; }
        private bool isOk { get; set; }
        private DataHelperModel model;
        public SummaryOutController(IntPtr handle) : base(handle)
        {
        }
        public override void ViewDidLoad()
        {
            base.ViewDidLoad();

            model = JsonConvert.DeserializeObject<DataHelperModel>(DataHelper);

            if (model.AccountNumber.Contains("http://"))
            {
                model.AccountNumber = model.AccountNumber.Replace("http://", "");
            }

            txtAccountNumber.Text = model.AccountNumber;

            txtOperator.Text = model.OperatorNumber + " " + model.OperatorName;
            txtCode.Text = model.ClockInOutResponse.ClockInOutOperationCode;
            txtDate.Text = model.ClockInOutResponse.ClockInDate;
            txtHours.Text = model.ClockInOutResponse.ClockInHours;

        }
        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
        }

        partial void BtnCancel_TouchUpInside(UIButton sender)
        {
            ViewController controller =
                 this.Storyboard.InstantiateViewController
                     ("ViewController") as ViewController;

            this.NavigationController.SetNavigationBarHidden(true, true);
            this.NavigationController.PushViewController(controller, true);
        }

        partial void BtnSaveOut_TouchUpInside(UIButton sender)
        {

            this.InvokeOnMainThread(() =>
            {
                bool check = false;

                var av = new UIAlertView("Confirm", "Do you want to clock out operator: " + model.OperatorNumber + " " + model.OperatorName + " ?", null, NSBundle.MainBundle.LocalizedString("No", "No"), NSBundle.MainBundle.LocalizedString("Yes", "Yes"));
                av.Clicked += (senderC, buttonArgs) => PopupResponse(buttonArgs.ButtonIndex != av.CancelButtonIndex);
                av.Show();
            });
        }

        void PopupResponse(bool check)
        {
            if (check)
            {
                this.InvokeOnMainThread(() =>
                {
                    UserDialogs.Instance.ShowLoading("Saving data...");
                });

                ClockInOutResponse resp = new ClockInOutResponse();


                API api = new API();

                var request = new RestRequest("api/ams/clockout?" +
                                              "accountNumber=" + model.AccountNumber +
                                              "&OperatorNumber=" + model.OperatorNumber, Method.GET);

                IRestResponse response = api.GetClient().Execute(request);

                string content = response.Content;

                this.InvokeOnMainThread(() =>
                {
                    UserDialogs.Instance.HideLoading();
                });

                if (response.IsSuccessful)
                {
                    resp = JsonConvert.DeserializeObject<ClockInOutResponse>(content);

                    this.InvokeOnMainThread(() =>
                    {
                        var av = new UIAlertView("Success", resp.ClockInOutMessage, null, "OK", null);
                        av.Clicked += delegate
                        {
                            ViewController controller =
                                this.Storyboard.InstantiateViewController
                                    ("ViewController") as ViewController;

                            this.NavigationController.SetNavigationBarHidden(true, true);
                            this.NavigationController.PushViewController(controller, true);
                        };
                        av.Show();
                    });
                }
                else
                {
                    this.InvokeOnMainThread(() =>
                    {
                        var av = new UIAlertView("Error", response.Content, null, "OK", null);
                        av.Show();
                    });
                }
            }
            else
            {
                return;
            }
        }
    }
}